 Type TAliens = Object
              {-----------------}
               S00 : TSPrite;
               Exp : Array[1..50] of Record
                      X, Y, XVel, YVel : Real;
                      Soort  : Word;
                      Active : Boolean;
                      Tracking : Boolean;
                      Score_ : Word;
                      Track  : Byte;
                      CannonX,
                      CannonY : Byte;
                      CannonType : Byte;
                      Poss   : Array[1..25] of Record
                                X,Y : Integer;
                               End;
                     End;
               Count : Byte;
              {-----------------}
               Procedure Load;
               Procedure DetectCollisions;
               Procedure SetStart(Which : Byte);
               Function Place(_Soort : Integer) : Byte;
               Procedure DrawAll;
              End;

 Var Aliens : TAliens;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TAliens.Load;
 Var Index : Byte;
 Begin
  S00.Load('ALIENS.WAD',1);
  For Index := 1 To 50 Do With Exp[Index] Do Begin
   X := 0; Y := 0; Soort := 1;  Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TAliens.DrawAll;
 Var Index : Byte;
 Begin
    DetectCollisions;
    Inc(Count);
    If Count = 15 Then Count := 0;
  For Index := 1 To 25 Do With Exp[Index] Do
   If Active Then Begin
     S00.GotoXY(Round(X),Round(Y));
     S00.Current := Soort;
     StuurNaar(Track, Poss[Track].X, Poss[Track].Y, X, Y, XVel, YVel, 0.05, 1);
     Case CannonType of
      1 : if Random(75) = 1 then Bullets.Shoot(Round(X)+CannonX,Round(Y)+CannonY,0,-2,6,Tracking);
      2 : if Random(100)  = 1 then Begin
           Bullets.Shoot(Round(X)+CannonX,Round(Y)+CannonY,0,-2,5,Tracking);
           Bullets.Shoot(Round(X)+CannonX+15,Round(Y)+CannonY,0,-2,5,Tracking);
          End;
      3 : Begin
           if Random(100) = 1 then Bullets.Shoot(Round(X)+CannonX,Round(Y)+CannonY,0,-2,9,Tracking);
           Case Count of
            0..5 : S00.Current := 3;
            6..10 : S00.Current := 4;
           Else S00.Current := 5;
           End;
         End;
     End;
     If Poss[Track].X = -1 Then Begin
      Active := False;
     End;
     S00.Draw;
   End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TAliens.DetectCollisions;
 Var Index : Byte;
     Index2 : Byte;
     Index3 : Byte;
     _X,_Y : Integer;
 Function Raakt(X1,Y1,X2,Y2 : Integer): Boolean;
 Begin
  IF (X2 > X1) and (X2 < X1+28) And
     (Y2 > Y1) and (Y2 < Y1+28) Then Raakt := True Else Raakt := False;
 End;
 Begin
  For Index := 1 To 50 Do With Exp[Index] Do Begin
   If Active Then Begin
   _X := Round(X);
   _Y := Round(Y);
    For Index2 := 1 To 25 Do If Bullets.Bul[Index2].Active Then
    If Raakt(_X,_Y,Round(Bullets.Bul[Index2].X), Round(Bullets.Bul[Index2].Y)) Then Begin
     Active := False;
     Bullets.Bul[Index2].Active := False;
     Live.Scores(Score_, Round(Exp[Index].X),Round(Exp[Index].Y));
     For Index3 := 1 To 4 Do
     Explosions.Place(Round(X+Random(16)),Round(Y+Random(16)),9);
    End;
   End;
  End;
 End;

 Procedure TAliens.SetStart;
 Begin
  With Exp[Which] Do Begin
   X := Poss[1].X; Y := Poss[1].Y;
  End;
 End;

 Function TAliens.Place;
 Var Index : Byte;
 Begin
  For Index := 1 To 50 Do With Exp[Index] Do Begin
   If Not Active Then Begin
    SetStart(Index); Soort := _Soort;
    Place := Index;
    XVel := 0;
    YVel := 0;
    Track := 1;
    Active := True;
    Break;
   End;
  End;
 End;
