 Type TLIVE = Object
              {-----------------}
               S00     : TSPrite;
               Over    : Integer;
               NuScore : LongInt;
               Speed   : Word;
              {-----------------}
               Procedure Load;
               Procedure Hit;
               Function  Dead : Boolean;
               Procedure UnHit;
               Procedure Scores(Punten : LongInt; XPos, YPos : Integer);
               Procedure DrawAll;
               Procedure SpeedUp;
               Procedure SpeedDown;
              End;

 Var Live : TLive;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.Load;
 Var Index : Byte;
 Begin
  S00.Load('SCORE.WAD',1);
  Over := 10;
  Speed := 2;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.SpeedUp;
 Begin
  If Speed < 4 Then Inc(Speed);
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.SpeedDown;
 Begin
  If Speed > 2 Then Dec(Speed);
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.DrawAll;
 Var Index : Byte;
     S : String;
 Begin
  For Index := 1 To 10 Do Begin
    S00.GotoXY((Index*7),2);
    If Over >= Index Then S00.Current := 2 Else S00.Current := 1;
    S00.Draw;
  End;
  S := INt2Str(NuScore);
  While Length(S) < 10 Do S := '0'+S;
  For Index := 1 To 10 Do Begin
    S00.GotoXY(275+(Index*7),2);
    S00.Current := Byte(S[Index])-45;
    S00.Draw;
  End;

 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.Scores;
 Begin
  Inc(Nuscore, Punten);
  If Xpos <> 0 Then
  LittleNumbers.Create(XPos,YPos, 30, Int2Str(Punten));
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.Hit;
 Begin
  Dec(Over);
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TLive.UnHit;
 Begin
  If Over < 10 Then Inc(Over);
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Function TLive.Dead : Boolean;
 Begin
  If Over < 1 Then Dead := TRue Else Dead := False;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)
