 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 (* Maximum Optimized *)

 Const TotalStars = 25;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Type TStars = Object
              {-----------------}
                Star : Array[1..TotalStars] of Record
                        X,Y         : WORD;
                        Color,YVelo : Byte;
                       End;
              {-----------------}
               Procedure Spread;
               Procedure Draw;
              {-----------------}
               End;

 Var Stars : TStars;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TStars.Spread; {Sandwich}
 Var Index : Byte;
 Begin
  For Index := 1 TO TotalStars Do With Star[Index] DO Begin
   X := Random(Screen_Width);
   Y := Random(Screen_Height);
   YVelo := +1;
   Case Random(6) of
    00..03 : Begin Color := 020; YVelo := 1; End;
    04..05 : Begin Color := 024; YVelo := 2; End;
    06     : Begin Color := 028; YVelo := 3; End;
   End;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TStars.Draw;
 Var Index, Calc : Byte;
 Begin
  For Index := 1 TO TotalStars Do With Star[Index] DO Begin
   Y := Y - YVelo;
   IF Y > Screen_Height Then Begin
    Y := Screen_Height;
    X := Random(Screen_Width);
   End;
   Point(X,Y,Color);
   Calc := 1 SHL (X AND 3);
   Asm MOV DX, $03C5; MOV AL, CALC; OUT DX, AL End;
   Mem[$A000:YOfs[Y]+(X Shr 2)+Page] := Color;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)
