 Type TBonus = Object
              {-----------------}
               S00 : TSPrite;
                    Bul : Array[1..5] of Record
                      X,Y    : Integer;
                      XVelo,
                      YVelo  : Integer;
                      Soort  : Word;
                      Active : Boolean;
                      Count  : Byte;
                      Count2 : Byte;
                     End;
              {-----------------}
               Procedure Load;
               Procedure Create(StartX : LongInt; StartY, _XVelo, _YVelo, _Soort : Integer);
               Procedure MoveAll;
               Procedure DrawAll;
              End;

 Var Bonus : TBonus;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBonus.Load;
 Var Index : Byte;
 Begin
  S00.Load('SPBONUS.WAD',1);
  For Index := 1 To 5 Do With Bul[Index] Do Begin
   X := 0; Y := 0; Soort := 1;  Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBonus.MoveAll;
 Function Tussen(A,B,C : Integer): Boolean;
 Begin
  IF (A < B) or (A > C) Then Tussen := True else tussen := False;
 End;
 Var Index : Byte;
 Begin
  For Index := 1 To 5 Do With Bul[Index] Do Begin
   Inc(Count);
   If Count = 10 Then Begin
    Count := 1;
    Inc(Count2);
    If Count2 = 5 Then Count2 := 1;
    If Count2 = 9 Then Count2 := 5;
    If Count2 = 15 Then Count2 := 9;
    End;
   X := X + XVelo;
   Y := Y + YVelo;
   If Tussen(X,0,Screen_Width) Then Active := False;
   If Tussen(Y,-50,Screen_Height+100) Then Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBonus.DrawAll;
 Var Index : Byte;
 Begin
  MoveAll;
  For Index := 1 To 5 Do With Bul[Index] Do
   If Active Then Begin
     S00.GotoXY(X,Y);
{     S00.Current := Soort;}
     S00.Current := Count2;
     S00.Draw;
{     S00.Current := 15;
     S00.Draw;}
   End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TBonus.Create;
 Var Index : Byte;
 Begin
  For Index := 1 To 5 Do With Bul[Index] Do Begin
   If Not Active Then Begin
    X := StartX; Y := StartY; XVelo := _XVelo; YVelo := _YVelo; Soort := _Soort;
    Count2 := Soort;
    Active := True;
    Break;
   End;
  End;
 End;
