 Type TScenary = Object
              {-----------------}
               S00 : TSPrite;
               Bul : Array[1..25] of Record
                      X,Y    : Integer;
                      Soort  : Word;
                      Active : Boolean;
                     End;
              {-----------------}
               Procedure Load;
               Procedure Shoot(StartX : LongInt; StartY, _Soort : Integer);
               Procedure DrawAll;
              End;

 Var Scenary : TScenary;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TSCENARY.Load;
 Var Index : Byte;
 Begin
  S00.Load('SPSCENAR.WAD',1);
  For Index := 1 To 25 Do With Bul[Index] Do Begin
   X := 0; Y := 0; Soort := 1;  Active := False;
  End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TSCENARY.DrawAll;
 Var Index : Byte;
 Begin
  For Index := 1 To 25 Do With Bul[Index] Do
   If Active Then Begin
     S00.GotoXY(X,Y);
     S00.Current := Soort;
     S00.Draw;
     Dec(Y);
     If Y < -32 Then Active := False;
   End;
 End;

 (*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\ - MAD SPACE - ////////////////////////////*)

 Procedure TSCENARY.Shoot;
 Var Index : Byte;
 Begin
  For Index := 1 To 25 Do With Bul[Index] Do Begin
   If Not Active Then Begin
    X := StartX; Y := StartY; Soort := _Soort;
    Active := True;
    Break;
   End;
  End;
 End;
